Package: biocmake
Version: 1.0.1
Date: 2025-05-13
Title: CMake for Bioconductor
Description: 
    Manages the installation of CMake for building Bioconductor packages.
    This avoids the need for end-users to manually install CMake on their system.
    No action is performed if a suitable version of CMake is already available.
Authors@R: person("Aaron", "Lun", role=c("cre", "aut"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Encoding: UTF-8
VignetteBuilder: knitr
Imports: utils, tools, dir.expiry
Suggests: knitr, rmarkdown, BiocStyle, testthat
biocViews: Infrastructure
URL: https://github.com/LTLA/biocmake
BugReports: https://github.com/LTLA/biocmake/issues
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/biocmake
git_branch: RELEASE_3_21
git_last_commit: 9cffd4f
git_last_commit_date: 2025-05-13
Repository: Bioconductor 3.21
Date/Publication: 2025-05-18
NeedsCompilation: no
Packaged: 2025-05-18 20:19:36 UTC; biocbuild
Author: Aaron Lun [cre, aut]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

#' Find Cmake 
#'
#' Find an existing Cmake installation or, if none can be found, install a \pkg{biocmake}-managed Cmake instance.
#'
#' @param command String containing the command to check for an existing installation.
#' @param minimum.version String specifying the minimum acceptable version of an existing installation.
#' @param can.download Logical scalar indicating whether to download Cmake if no acceptable existing installation can be found.
#' @param ... Further arguments to pass to \code{\link{download}}.
#'
#' @details
#' If the \code{BIOCMAKE_FIND_OVERRIDE} environment variable is set to a command or path to a Cmake executable,
#' it is returned directly and all other options are ignored.
#'
#' On Windows, it is strongly recommended to download Rtools (see \url{https://cran.r-project.org/bin/windows/Rtools/rtools44/rtools.html}).
#' This provides a pre-configured Cmake that is guaranteed to work.
#'
#' @return String containing the command to use to run Cmake.
#'
#' @author Aaron Lun
#' @examples
#' cmd <- find()
#' system2(cmd, "--version")
#'
#' @export
find <- function(
    command=defaultCommand(),
    minimum.version=defaultMinimumVersion(),
    can.download=TRUE,
    ...)
{
    override <- Sys.getenv("BIOCMAKE_FIND_OVERRIDE", NA)
    if (!is.na(override)) {
        return(override)
    }

    if (Sys.which(command) != "") {
        version <- get_version(command)
        if (!is.na(version) && version >= minimum.version) {
            return(command)
        }
    }

    if (!can.download) {
        return(NULL)
    }

    download(...)
}

get_version <- function(command) {
    test <- system2(command, "--version", stdout=TRUE)
    vstring <- test[grep("cmake version ", test[1])]
    vstring <- gsub("cmake version ", "", vstring)
    to_version(vstring)
}

to_version <- function(version) {
    # Remove modifiers like -alpha, -beta, rc1, etc.
    if (grepl("^[0-9]+\\.[0-9]+\\.[0-9]+[^0-9]", version)) {
        version <- sub("^([0-9]+\\.[0-9]+\\.[0-9]+)[^0-9].*", "\\1", version)
    }
    package_version(version, strict=FALSE)
}

# library(testthat); library(biocmake); source("setup.R"); source("test-find.R")

test_that("find() returns a valid path", {
    out <- find()
    expect_true(Sys.which(out) != "" || file.exists(out))

    ver <- biocmake:::get_version(out)
    expect_match(as.character(ver), "^[0-9]+\\.[0-9]+\\.[0-9]+$")
})

test_that("find() respects the minimum required version", {
    out <- find(minimum.version=package_version("1000.1000.1000"), can.download=FALSE)
    expect_null(out)
})

test_that("find() respects the override", {
    old <- Sys.getenv("BIOCMAKE_FIND_OVERRIDE", NA)
    Sys.setenv(BIOCMAKE_FIND_OVERRIDE="foobar")
    if (is.na(old)) {
        on.exit(Sys.unsetenv("BIOCMAKE_FIND_OVERRIDE"))
    } else {
        Sys.setenv(BIOCMAKE_FIND_OVERRIDE=old)
    }

    out <- find()
    expect_identical(out, "foobar")
})

test_that("find() works in a mock project", {
    project <- mock()
    build <- compile(find(), project)
    expect_true(file.exists(file.path(build, "libsuperfoo.a")))
})

test_that("to_version() works for weird versions", {
    expect_identical(biocmake:::to_version("1.1.1-alpha"), package_version("1.1.1"))
    expect_identical(biocmake:::to_version("3.23.39a"), package_version("3.23.39"))
    expect_identical(biocmake:::to_version("4.0.2-dirty"), package_version("4.0.2"))
    expect_true(is.na(biocmake:::to_version("1.1-foo")))
})

#' Download Cmake
#'
#' Download Cmake binaries for the current architecture.
#' This uses \pkg{dir.expiry} to remove unused versions of the \pkg{biocmake}-managed Cmake.
#'
#' @param download.version String specifying the Cmake version to download.
#' @param cache.dir String specifying the location of the directory in which to cache Cmake installations.
#' @param ignore.cache Logical scalar specifying whether to ignore any existing cached version of Cmake,
#' in which case the binaries will be downloaded again.
#'
#' @return String containing the path to the Cmake executable.
#' @author Aaron Lun
#'
#' @examples
#' download()
#'
#' @export
#' @importFrom utils untar unzip
download <- function(download.version=defaultDownloadVersion(), cache.dir=defaultCacheDirectory(), ignore.cache=FALSE) {
    if (.Platform$OS.type == "windows") {
        output <- get_cmake(download.version, cache.dir=cache.dir, ignore.cache=ignore.cache, formatter=get_windows_format, unpacker=unzip)
        return(file.path(output, "bin", "cmake.exe"))
    }

    sinfo <- Sys.info()
    ssys <- sinfo[["sysname"]]
    if (ssys == "Darwin") {
        output <- get_cmake(download.version, cache.dir=cache.dir, ignore.cache=ignore.cache, formatter=get_mac_format, unpacker=untar)
        return(file.path(output, "CMake.app", "Contents", "bin", "cmake"))
    }

    output <- get_cmake(download.version, cache.dir=cache.dir, ignore.cache=ignore.cache, formatter=get_linux_format, unpacker=untar)
    file.path(output, "bin", "cmake")
}

get_linux_format <- function() {
    sinfo <- Sys.info()
    smach  <- sinfo[["machine"]]
    if (smach == "aarch64") {
        "cmake-%s-linux-aarch64.tar.gz"
    } else {
        "cmake-%s-linux-x86_64.tar.gz"
    }
}

get_mac_format <- function() "cmake-%s-macos-universal.tar.gz"

get_windows_format <- function() {
    sinfo <- Sys.info()
    smach  <- sinfo[["machine"]]
    if (smach %in% c("x86_64", "x86-64")) {
        "cmake-%s-windows-x86_64.zip"
    } else {
        "cmake-%s-windows-arm64.zip"
    }
}

#' @importFrom utils download.file
#' @import dir.expiry
get_cmake <- function(download.version, cache.dir, ignore.cache, formatter, unpacker) {
    output <- file.path(cache.dir, download.version)
    lck <- lockDirectory(output, exclusive=(!file.exists(output) || ignore.cache))
    on.exit(unlockDirectory(lck), add=TRUE, after=FALSE)

    if (ignore.cache) {
        unlink(output, recursive=TRUE)
    }

    if (!file.exists(output)) {
        format <- formatter()
        url <- paste0("https://github.com/Kitware/CMake/releases/download/v", download.version, "/", sprintf(format, download.version))
        full.path <- tempfile()
        if (download.file(url, full.path) != 0) {
            stop("failed to download file from '", url, "'")
        }
        on.exit(unlink(full.path), add=TRUE, after=FALSE)

        tmp <- tempfile(tmpdir=cache.dir)
        on.exit(unlink(tmp, recursive=TRUE), add=TRUE, after=FALSE)
        unpacker(full.path, exdir=tmp)

        listing <- list.files(tmp)
        stopifnot(length(listing) == 1L)
        inner <- file.path(tmp, listing[1]) # reducing some of the nesting.
        if (!file.rename(inner, output)) {
            stop("failed to move cmake binaries to the cache directory")
        }
    }

    touchDirectory(output)
    output
}

#' Defaults for \pkg{biocmake}
#'
#' @return
#' For \code{defaultCommand}, a string specifying the expected command-line invocation of an existing Cmake installation.
#' 
#' For \code{defaultDownloadVersion}, a string specifying the version of Cmake to download if no existing installation can be found.
#'
#' For \code{defaultMinimumVersion}, a string specifying the minimum version of an existing Cmake installation.
#'
#' For \code{defaultCacheDirectory}, a string containing the path to the cache directory for \pkg{biocmake}-managed Cmake installations.
#'
#' @details
#' The \code{BIOCMAKE_CMAKE_COMMAND} environment variable will override the default setting of \code{defaultCommand}.
#'
#' The \code{BIOCMAKE_CMAKE_DOWNLOAD_VERSION} environment variable will override the default setting of \code{defaultDownloadVersion}.
#'
#' The \code{BIOCMAKE_CMAKE_MINIMUM_VERSION} environment variable will override the default setting of \code{defaultMinimumVersion}.
#'
#' The \code{BIOCMAKE_CMAKE_CACHE_DIRECTORY} environment variable will override the default setting of \code{defaultCacheDirectory}.
#'
#' @author Aaron Lun
#' @examples
#' defaultCommand()
#' defaultDownloadVersion()
#' defaultMinimumVersion()
#' defaultCacheDirectory()
#' 
#' @name defaults
NULL

#' @export
#' @rdname defaults
defaultCommand <- function() {
    Sys.getenv("BIOCMAKE_CMAKE_COMMAND", "cmake")
}


#' @export
#' @rdname defaults
defaultDownloadVersion <- function() {
    Sys.getenv("BIOCMAKE_CMAKE_DOWNLOAD_VERSION", "3.30.3")
}

#' @export
#' @rdname defaults
defaultMinimumVersion <- function() {
    Sys.getenv("BIOCMAKE_CMAKE_MINIMUM_VERSION", "3.24.0")
}

#' @export
#' @importFrom tools R_user_dir
#' @rdname defaults
defaultCacheDirectory <- function() {
    Sys.getenv("BIOCMAKE_CMAKE_CACHE_DIRECTORY", R_user_dir("biocmake", "cache"))
}

#' Configure Cmake 
#'
#' Propagate R's configuration variables into the Cmake options, where possible.
#'
#' @param c.compiler Logical scalar indicating whether to propagate R's choice of C compiler.
#' @param c.flags Logical scalar indicating whether to propagate R's choice of C flags.
#' @param cxx.compiler Logical scalar indicating whether to propagate R's choice of C++ compiler.
#' @param cxx.flags Logical scalar indicating whether to propagate R's choice of C++ flags.
#' @param fortran.compiler Logical scalar indicating whether to propagate R's choice of Fortran compiler.
#' @param fortran.flags Logical scalar indicating whether to propagate R's choice of Fortran flags.
#' @param cpp.flags Logical scalar indicating whether to propagate R's choice of C/C++ preprocessing flags.
#' @param pic.flags Logical scalar indicating whether to propagate R's choice of each language's position-independent flags.
#' This also sets the \code{CMAKE_POSITION_INDEPENDENT_CODE} variable.
#' @param ld.flags Logical scalar indicating whether to add R's choice of linker flags to the CMake variables for each target type.
#' @param make Logical scalar indicating whether to propagate R's choice of \code{make} command.
#' @param ar Logical scalar indicating whether to propagate R's choice of command to make static libraries.
#' @param ranlib Logical scalar indicating whether to propagate R's choice of command to index static libraries.
#' @param release.build Logical scalar indicating whether to configure Cmake for a release build.
#' Note that this has no effect on Windows, where the release flags must be set during the build itself.
#' @param options Character vector of optional arguments from \code{configure}.
#'
#' @return
#' For \code{configure}, a named character vector containing the name and value of each option.
#'
#' For \code{formatArguments}, a character vector with Cmake arguments on the command line.
#' \code{NA} values are ignored, and values with spaces or empty strings are quoted.
#'
#' @author Aaron Lun
#'
#' @examples
#' options <- configure()
#' options
#' formatArguments(options)
#'
#' @export
configure <- function(
    c.compiler=TRUE,
    c.flags=c.compiler,
    cxx.compiler=TRUE,
    cxx.flags=cxx.compiler,
    fortran.compiler=TRUE,
    fortran.flags=fortran.compiler,
    cpp.flags=c.compiler || cxx.compiler,
    pic.flags=TRUE,
    ld.flags=c("exe", "module", "shared"),
    make=TRUE,
    ar=TRUE,
    ranlib=TRUE,
    release.build=TRUE)
{
    options <- list()

    if (pic.flags) {
        options[["CMAKE_POSITION_INDEPENDENT_CODE"]] <- "ON"
    }

    if (release.build && .Platform$OS.type != "windows") {
        options[["CMAKE_BUILD_TYPE"]] <- "Release" # this doesn't work on windows as the release flag is set elsewhere.
    }

    if (Sys.info()[["sysname"]] == "Darwin") {
         options[["CMAKE_OSX_DEPLOYMENT_TARGET"]] <- "" # avoiding hard-coding of exact OSX version.
    }

    if (.Platform$OS.type == "windows") {
        r.bin <- "R.exe"
    } else {
        r.bin <- "R"
    }
    r.self <- file.path(R.home("bin"), r.bin)

    precursor <- character()
    if (cpp.flags) {
        precursor <- system2(r.self, c("CMD", "config", "CPPFLAGS"), stdout=TRUE)
    }

    if (c.compiler) {
        out <- system2(r.self, c("CMD", "config", "CC"), stdout=TRUE)
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_C_COMPILER"]] <- out
        }
    }

    if (c.flags) {
        out <- c(precursor, system2(r.self, c("CMD", "config", "CFLAGS"), stdout=TRUE))
        if (pic.flags) {
            out <- c(out, system2(r.self, c("CMD", "config", "CPICFLAGS"), stdout=TRUE))
        }
        out <- compact(out)
        if (out != "") {
            options[["CMAKE_C_FLAGS"]] <- out
        }
    }

    if (cxx.compiler) {
        out <- system2(r.self, c("CMD", "config", "CXX"), stdout=TRUE)
        out <- sub(" -std=[^ ]*", "", out) # stripping standard specification.
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_CXX_COMPILER"]] <- out
        }
    }

    if (cxx.flags) {
        out <- c(precursor, system2(r.self, c("CMD", "config", "CXXFLAGS"), stdout=TRUE))
        if (pic.flags) {
            out <- c(out, system2(r.self, c("CMD", "config", "CXXPICFLAGS"), stdout=TRUE))
        }
        out <- compact(out)
        if (out != "") {
            options[["CMAKE_CXX_FLAGS"]] <- out
        }
    }

    if (fortran.compiler) {
        out <- system2(r.self, c("CMD", "config", "FC"), stdout=TRUE)
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_FORTRAN_COMPILER"]] <- out
        }
    }

    if (fortran.flags) {
        out <- system2(r.self, c("CMD", "config", "FFLAGS"), stdout=TRUE)
        if (pic.flags) {
            out <- c(out, system2(r.self, c("CMD", "config", "FPICFLAGS"), stdout=TRUE))
        }
        out <- compact(out)
        if (out != "") {
            options[["CMAKE_FORTRAN_FLAGS"]] <- out
        }
    }

    if (make) {
        out <- system2(r.self, c("CMD", "config", "MAKE"), stdout=TRUE)
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_MAKE_PROGRAM"]] <- out
        }
    }

    if (ar) {
        out <- sub(" .*", "", system2(r.self, c("CMD", "config", "AR"), stdout=TRUE))
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_AR"]] <- out
        }
    }

    if (ranlib) {
        out <- sub(" .*", "", system2(r.self, c("CMD", "config", "RANLIB"), stdout=TRUE))
        if (Sys.which(out) != "" || file.exists(out)) {
            options[["CMAKE_RANLIB"]] <- out
        }
    }

    ld.flags <- match.arg(ld.flags, several.ok=TRUE)
    if (length(ld.flags)) {
        out <- sub(" .*", "", system2(r.self, c("CMD", "config", "LDFLAGS"), stdout=TRUE))
        if (out != "") {
            for (type in ld.flags) {
                options[[sprintf("CMAKE_%s_LINKER_FLAGS", toupper(type))]] <- out
            }
        }
    }

    unlist(options)
}

compact <- function(x) {
    x <- x[x != ""]
    paste(x, collapse=" ")
}

#' @export
#' @rdname configure
formatArguments <- function(options) {
    options <- options[!is.na(options)]
    needs.quote <- grepl(" ", options) | options == ""
    options[needs.quote] <- shQuote(options[needs.quote])
    options <- sprintf("-D%s=%s", names(options), options)
}

# library(testthat); library(biocmake); source("test-configure.R")

test_that("configure() works with all options on", {
    opt <- configure()
    expect_true(all(startsWith(names(opt), "CMAKE_")))
})

test_that("argument formatting works correctly", {
    out <- formatArguments(c(CMAKE_A="g++", CMAKE_B="foo bar", CMAKE_C=""))
    expect_identical(out[1], "-DCMAKE_A=g++")
    expect_match(out[2], "-DCMAKE_B=.foo bar.")
    expect_match(out[3], "-DCMAKE_C=..")
})

mock <- function() {
    project <- tempfile()
    dir.create(project)

    write(file=file.path(project, "CMakeLists.txt"), '
cmake_minimum_required(VERSION 3.25)

project(bctest VERSION 2.0.1 LANGUAGES CXX)

add_library(superfoo src/superfoo.cpp)
target_include_directories(superfoo PUBLIC include)
')

    dir.create(file.path(project, "src"))
    write(file=file.path(project, "src", "superfoo.cpp"), '
int superfoo(int a, int b) {
    return a + b;
}
')

    dir.create(file.path(project, "include"))
    write(file=file.path(project, "include", "superfoo.h"), '
#ifndef SUPERFOO_H
#define SUPERFOO_H

int superfoo(int, int);

#endif
')

    project
}

compile <- function(command, project) {
    # Removing some of the configuration parameters that we don't need.
    config <- biocmake::configure(c.compiler=FALSE, fortran.compiler=FALSE)
    config.args <- biocmake::formatArguments(config)

    build <- tempfile()
    status <- system2(command, c(config.args, "-S", project, "-B", build))
    stopifnot(status == 0L)

    status <- system2(command, c("--build", build))
    stopifnot(status == 0L)

    build
}

# library(testthat); library(biocmake); source("test-download.R")

test_that("download() works as expected", {
    path <- download()
    expect_identical(download(), path) # just re-uses the cached path.

    # Checking that we can actually run the binary.
    ver <- biocmake:::get_version(path)
    expect_match(as.character(ver), "^[0-9]+\\.[0-9]+\\.[0-9]+$")
})

test_that("download() works in a mock project", {
    skip_on_os("windows") # Downloaded version doesn't work; use Rtools's version.
    project <- mock()
    build <- compile(download(), project)
    expect_true(file.exists(file.path(build, "libsuperfoo.a")))
})

## ----echo=FALSE, results="hide", message=FALSE--------------------------------
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)

library(BiocStyle)
self <- Biocpkg("biocmake")

## -----------------------------------------------------------------------------
biocmake::find()

## -----------------------------------------------------------------------------
project <- tempfile()
dir.create(project)

write(file=file.path(project, "CMakeLists.txt"), '
cmake_minimum_required(VERSION 3.25)

project(bctest VERSION 2.0.1 LANGUAGES CXX)

add_library(superfoo src/superfoo.cpp)
target_include_directories(superfoo PUBLIC include)
')

dir.create(file.path(project, "src"))
write(file=file.path(project, "src", "superfoo.cpp"), '
int superfoo(int a, int b) {
    return a + b;
}
')

dir.create(file.path(project, "include"))
write(file=file.path(project, "include", "superfoo.h"), '
#ifndef SUPERFOO_H
#define SUPERFOO_H

int superfoo(int, int);

#endif
')

## -----------------------------------------------------------------------------
# Removing some of the configuration parameters that we don't need.
config <- biocmake::configure(c.compiler=FALSE, fortran.compiler=FALSE)
config.args <- biocmake::formatArguments(config)

cmake <- biocmake::find()
build <- tempfile()
status <- system2(cmake, c(config.args, "-S", project, "-B", build))
stopifnot(status == 0L)

status <- system2(cmake, c("--build", build))
stopifnot(status == 0L)

## -----------------------------------------------------------------------------
biocmake::defaultCommand()
biocmake::defaultMinimumVersion()
biocmake::defaultDownloadVersion()
biocmake::defaultCacheDirectory()

## -----------------------------------------------------------------------------
Sys.setenv(BIOCMAKE_CMAKE_MINIMUM_VERSION="3.27.4")
biocmake::defaultMinimumVersion()

## -----------------------------------------------------------------------------
sessionInfo()

---
title: Cmake for Bioconductor
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
date: "Revised: September 18, 2024"
output:
  BiocStyle::html_document
package: biocmake
vignette: >
  %\VignetteIndexEntry{Cmake for Bioconductor}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)

library(BiocStyle)
self <- Biocpkg("biocmake")
```

# Overview

`r self` provides consistent access to [Cmake](https://cmake.org) for use in building Bioconductor packages.
The idea is to check if an appropriate version of Cmake is already available on the host machine,
and if not, download and install a local copy of Cmake managed by `r self`.
This avoids for end-users to manually install Cmake via `SystemRequirements: cmake`.
To find the Cmake executable:

```{r}
biocmake::find()
```

This will return either the Cmake command on the `PATH` (if it is of a suitable version).
or will return the cached path to a Cmake executable after downloading the binaries (otherwise).
Developers can use this in a system call in their `configure` scripts to build Cmake projects for their own packages.

# Worked example

Let's mock up a Cmake project.

```{r}
project <- tempfile()
dir.create(project)

write(file=file.path(project, "CMakeLists.txt"), '
cmake_minimum_required(VERSION 3.25)

project(bctest VERSION 2.0.1 LANGUAGES CXX)

add_library(superfoo src/superfoo.cpp)
target_include_directories(superfoo PUBLIC include)
')

dir.create(file.path(project, "src"))
write(file=file.path(project, "src", "superfoo.cpp"), '
int superfoo(int a, int b) {
    return a + b;
}
')

dir.create(file.path(project, "include"))
write(file=file.path(project, "include", "superfoo.h"), '
#ifndef SUPERFOO_H
#define SUPERFOO_H

int superfoo(int, int);

#endif
')
```

We then use `r self` to build it through the Cmake executable identified by `find()`.
The `configure()` command collects some compilation settings used to build R itself and propagates this to the Cmake project,
e.g., to ensure that the same compilers are used.

```{r}
# Removing some of the configuration parameters that we don't need.
config <- biocmake::configure(c.compiler=FALSE, fortran.compiler=FALSE)
config.args <- biocmake::formatArguments(config)

cmake <- biocmake::find()
build <- tempfile()
status <- system2(cmake, c(config.args, "-S", project, "-B", build))
stopifnot(status == 0L)

status <- system2(cmake, c("--build", build))
stopifnot(status == 0L)
```

Developers should execute these commands in their package's `configure(.win)` file.
This ensures that the CMake project is built first so that it is available for linking to the package's shared library.

# Setting defaults

Most default behaviors of `r self` are documented in the following functions,
which can in turn be controlled by environment variables.

```{r}
biocmake::defaultCommand()
biocmake::defaultMinimumVersion()
biocmake::defaultDownloadVersion()
biocmake::defaultCacheDirectory()
```

For example:

```{r}
Sys.setenv(BIOCMAKE_CMAKE_MINIMUM_VERSION="3.27.4")
biocmake::defaultMinimumVersion()
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/configure.R
\name{configure}
\alias{configure}
\alias{formatArguments}
\title{Configure Cmake}
\usage{
configure(
  c.compiler = TRUE,
  c.flags = c.compiler,
  cxx.compiler = TRUE,
  cxx.flags = cxx.compiler,
  fortran.compiler = TRUE,
  fortran.flags = fortran.compiler,
  cpp.flags = c.compiler || cxx.compiler,
  pic.flags = TRUE,
  ld.flags = c("exe", "module", "shared"),
  make = TRUE,
  ar = TRUE,
  ranlib = TRUE,
  release.build = TRUE
)

formatArguments(options)
}
\arguments{
\item{c.compiler}{Logical scalar indicating whether to propagate R's choice of C compiler.}

\item{c.flags}{Logical scalar indicating whether to propagate R's choice of C flags.}

\item{cxx.compiler}{Logical scalar indicating whether to propagate R's choice of C++ compiler.}

\item{cxx.flags}{Logical scalar indicating whether to propagate R's choice of C++ flags.}

\item{fortran.compiler}{Logical scalar indicating whether to propagate R's choice of Fortran compiler.}

\item{fortran.flags}{Logical scalar indicating whether to propagate R's choice of Fortran flags.}

\item{cpp.flags}{Logical scalar indicating whether to propagate R's choice of C/C++ preprocessing flags.}

\item{pic.flags}{Logical scalar indicating whether to propagate R's choice of each language's position-independent flags.
This also sets the \code{CMAKE_POSITION_INDEPENDENT_CODE} variable.}

\item{ld.flags}{Logical scalar indicating whether to add R's choice of linker flags to the CMake variables for each target type.}

\item{make}{Logical scalar indicating whether to propagate R's choice of \code{make} command.}

\item{ar}{Logical scalar indicating whether to propagate R's choice of command to make static libraries.}

\item{ranlib}{Logical scalar indicating whether to propagate R's choice of command to index static libraries.}

\item{release.build}{Logical scalar indicating whether to configure Cmake for a release build.
Note that this has no effect on Windows, where the release flags must be set during the build itself.}

\item{options}{Character vector of optional arguments from \code{configure}.}
}
\value{
For \code{configure}, a named character vector containing the name and value of each option.

For \code{formatArguments}, a character vector with Cmake arguments on the command line.
\code{NA} values are ignored, and values with spaces or empty strings are quoted.
}
\description{
Propagate R's configuration variables into the Cmake options, where possible.
}
\examples{
options <- configure()
options
formatArguments(options)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download.R
\name{download}
\alias{download}
\title{Download Cmake}
\usage{
download(
  download.version = defaultDownloadVersion(),
  cache.dir = defaultCacheDirectory(),
  ignore.cache = FALSE
)
}
\arguments{
\item{download.version}{String specifying the Cmake version to download.}

\item{cache.dir}{String specifying the location of the directory in which to cache Cmake installations.}

\item{ignore.cache}{Logical scalar specifying whether to ignore any existing cached version of Cmake,
in which case the binaries will be downloaded again.}
}
\value{
String containing the path to the Cmake executable.
}
\description{
Download Cmake binaries for the current architecture.
This uses \pkg{dir.expiry} to remove unused versions of the \pkg{biocmake}-managed Cmake.
}
\examples{
download()

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find.R
\name{find}
\alias{find}
\title{Find Cmake}
\usage{
find(
  command = defaultCommand(),
  minimum.version = defaultMinimumVersion(),
  can.download = TRUE,
  forget = FALSE,
  ...
)
}
\arguments{
\item{command}{String containing the command to check for an existing installation.}

\item{minimum.version}{String specifying the minimum acceptable version of an existing installation.}

\item{can.download}{Logical scalar indicating whether to download Cmake if no acceptable existing installation can be found.}

\item{forget}{Logical scalar indicating whether to forget the results of the last call.}

\item{...}{Further arguments to pass to \code{\link{download}}.}
}
\value{
String containing the command to use to run Cmake.
}
\description{
Find an existing Cmake installation or, if none can be found, install a \pkg{biocmake}-managed Cmake instance.
}
\details{
If the \code{BIOCMAKE_FIND_OVERRIDE} environment variable is set to a command or path to a Cmake executable, it is returned directly and all other options are ignored.

On Windows, it is strongly recommended to download Rtools (see \url{https://cran.r-project.org/bin/windows/Rtools/rtools44/rtools.html}).
This provides a pre-configured Cmake that is guaranteed to work.

By default, \code{find} will remember the result of its last call in the current R session, to avoid re-checking the versions, cache, etc.
This can be disabled by setting \code{forget=TRUE} to force a re-check, e.g., to detect a new version of Cmake that was installed while the R session is active.
}
\examples{
cmd <- find()
system2(cmd, "--version")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defaults.R
\name{defaults}
\alias{defaults}
\alias{defaultCommand}
\alias{defaultDownloadVersion}
\alias{defaultMinimumVersion}
\alias{defaultCacheDirectory}
\title{Defaults for \pkg{biocmake}}
\usage{
defaultCommand()

defaultDownloadVersion()

defaultMinimumVersion()

defaultCacheDirectory()
}
\value{
For \code{defaultCommand}, a string specifying the expected command-line invocation of an existing Cmake installation.

For \code{defaultDownloadVersion}, a string specifying the version of Cmake to download if no existing installation can be found.

For \code{defaultMinimumVersion}, a string specifying the minimum version of an existing Cmake installation.

For \code{defaultCacheDirectory}, a string containing the path to the cache directory for \pkg{biocmake}-managed Cmake installations.
}
\description{
Defaults for \pkg{biocmake}
}
\details{
The \code{BIOCMAKE_CMAKE_COMMAND} environment variable will override the default setting of \code{defaultCommand}.

The \code{BIOCMAKE_CMAKE_DOWNLOAD_VERSION} environment variable will override the default setting of \code{defaultDownloadVersion}.

The \code{BIOCMAKE_CMAKE_MINIMUM_VERSION} environment variable will override the default setting of \code{defaultMinimumVersion}.

The \code{BIOCMAKE_CMAKE_CACHE_DIRECTORY} environment variable will override the default setting of \code{defaultCacheDirectory}.
}
\examples{
defaultCommand()
defaultDownloadVersion()
defaultMinimumVersion()
defaultCacheDirectory()

}
\author{
Aaron Lun
}
